<template>
<div>
    <form>
        <numeric-field :title="balance_title" :min="balance_min" :required="balance_required" :value="balance" :setValue="setBalance"/>
        <drop-down-field :title="currency_title" :options="currencies" :required="currency_required" :choice="currency" :setChoice="setCurrency"/>
        <button-field :title="submit_title" :onClick="submit"/>
    </form>
</div>
</template>

<script>
import './CreateAccountForm.css';
import {mapActions, mapState, mapGetters} from 'vuex';
import {BALANCE_GETTER, CURRENCY_GETTER} from '../../store/CreateAccountModule/getters';
import {CREATE_ACCOUNT_SUBMIT_ACTION, SET_BALANCE_ACTION, SET_CURRENCY_ACTION} from '../../store/CreateAccountModule/actions';
import {CURRENCIES_VALUES_SETTING_ACTION} from '../../store/CurrencyModule/actions';

export default {
    data () {
	    return { 
            balance_title: "Balance",
            balance_min: 0,
            balance_required: "true",
            currency_title: "Currency",
            currency_required: "true",
            submit_title: "Create Account"
         } 
    },
    computed: {
        balance: {
            ...mapActions({set: SET_BALANCE_ACTION}),
            ...mapGetters({get: BALANCE_GETTER})
        },
        currency: {
            ...mapActions({set: SET_CURRENCY_ACTION}),
            ...mapGetters({get: CURRENCY_GETTER})
        },
        ...mapState({ currencies: state => state.currencyModule.currencies }),
    },
    methods: {
        setCurrency(choice){
            this.currency=choice;
        },
        setBalance(value){
            this.balance=value;
        },
        ...mapActions([CREATE_ACCOUNT_SUBMIT_ACTION, CURRENCIES_VALUES_SETTING_ACTION])
    },
    created(){
		this.setCurrencies();
	} 
}
</script>